import { Component,Inject,ViewChild } from '@angular/core';
import { DataSvc}  from "./services/DataSvc";
import * as wjCore from "wijmo/wijmo";
import * as wjGrid from "wijmo/wijmo.grid";
import * as wjGridXlsx from "wijmo/wijmo.grid.xlsx";
import { DataType } from 'wijmo/wijmo';


@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',

})
export class AppComponent {
  public data:wjCore.CollectionView;
  public frozenColumns:number;
  public columns: any;

  constructor(@Inject(DataSvc) _dataSvc : DataSvc){
    this.data= new wjCore.CollectionView(_dataSvc.getData(1000));
    this.frozenColumns=5;
  }
  @ViewChild("grid") flex: wjGrid.FlexGrid;
  itemformatter=(panel,r,c,cell)=>{
    if(panel.cellType==wjGrid.CellType.Cell){
      if(panel.columns[c].dataType==DataType.Number){
        cell.innerHTML="<i> "+cell.textContent+" % </i>";
      }
    }
  }
  ngAfterViewInit(){
    console.log(wjCore.getVersion())
    this.columns = [];
    for(let prop in this.data.items[0]){
      this.columns.push({
        binding:prop,
        header:prop.toUpperCase(),
        dataType:wjCore.getType(this.data.items[0][prop]),
        format: wjCore.getType(this.data.items[0][prop]) == DataType.Number ? 'n2' :undefined
      })
    }
  }
}
